Package tigase.xmpp.impl

## Class LastActivity

- java.lang.Object
- - tigase.xmpp.XMPPProcessor
  - - tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor
    - - tigase.xmpp.XMPPProcessorAbstract
      - - tigase.xmpp.impl.LastActivity

- All Implemented Interfaces:
    `java.lang.Comparable<XMPPImplIfc>`, `LastActivityRetriever`, `XMPPImplIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

      @Bean(name="jabber:iq:last",
            parent=LastActivityMarker.class,
            active=true)
      public class LastActivity
      extends XMPPProcessorAbstract
      implements LastActivityRetriever

  Implementation of XEP-0012: Last Activity.
  Author:
    bmalkow

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected static java.lang.String` | `ID` |

    - ### Fields inherited from class tigase.xmpp.XMPPProcessor

      `ALL_NAMES, ALL_PATHS, cmpInfo`

    - ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

      `CLIENT_XMLNS`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `LastActivity()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected static RosterAbstract` | `getRosterUtil()` |
    `void` | `process​(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` |
    `void` | `processFromUserPacket​(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | The method is called for all packets sent by the user, owner of this connection/session.
    `void` | `processFromUserToServerPacket​(JID connectionId, Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...).
    `void` | `processNullSessionPacket​(Packet packet, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | The method is called for packets received by the server for which no user session is found - neither sender session or receiver session.
    `void` | `processServerSessionPacket​(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | The method is called when a packet addressed to the server domain is received.
    `void` | `processToUserPacket​(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, java.util.Queue<Packet> results, java.util.Map<java.lang.String,​java.lang.Object> settings)` | Method is called for all the packets sent TO the user - owner of the session.

    - ### Methods inherited from class tigase.xmpp.XMPPProcessorAbstract

      `isFromUserSession, isNullSession, isServerSession, isToUserSession, processFromUserOutPacket`

    - ### Methods inherited from class tigase.xmpp.impl.annotation.AnnotatedXMPPProcessor

      `id, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

    - ### Methods inherited from class tigase.xmpp.XMPPProcessor

      `canHandle, compareTo, concurrentQueuesNo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

    - ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

      `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, id, init, supDiscoFeatures, supElementNamePaths, supNamespaces, supStreamFeatures, supTypes`

- - ### Field Detail

    - #### ID

          protected static final java.lang.String ID

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### LastActivity

          public LastActivity()

  - ### Method Detail

    - #### getRosterUtil

          protected static RosterAbstract getRosterUtil()

    - #### process

          public void process​(Packet packet,
                              XMPPResourceConnection session,
                              NonAuthUserRepository repo,
                              java.util.Queue<Packet> results,
                              java.util.Map<java.lang.String,​java.lang.Object> settings)
                       throws XMPPException

      Specified by:
        `process` in interface `XMPPProcessorIfc`
      Overrides:
        `process` in class `XMPPProcessorAbstract`
      Parameters:
        `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
        `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
        `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
        `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
        `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
      Throws:
        `XMPPException`

    - #### processFromUserPacket

          public void processFromUserPacket​(JID connectionId,
                                            Packet packet,
                                            XMPPResourceConnection session,
                                            NonAuthUserRepository repo,
                                            java.util.Queue<Packet> results,
                                            java.util.Map<java.lang.String,​java.lang.Object> settings)
                                     throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called for all packets sent by the user, owner of this connection/session. Please note, it is likely that a user sends a packet addressed to his own server, like get server version information. In such a case only this method is called. Such a packet is not later passed to the `processServerSessionPacket(...)`. Note, the default implementation checks whether the packet is addressed to the server or is being sent to another XMPP entity. In the first case it calls `processFromUserToServerPacket(...)` method, otherwise it calls `processFromUserOutPacket`. You can overwrite the method to change the default behavior or implement the two called methods to handle each case separately.
      Overrides:
        `processFromUserPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `connectionId` - is a `JID` instance with the session connection ID.
        `packet` - is a `Packet` sent by the user.
        `session` - is a `XMPPResourceConnection` instance with all the sending user session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### processFromUserToServerPacket

          public void processFromUserToServerPacket​(JID connectionId,
                                                    Packet packet,
                                                    XMPPResourceConnection session,
                                                    NonAuthUserRepository repo,
                                                    java.util.Queue<Packet> results,
                                                    java.util.Map<java.lang.String,​java.lang.Object> settings)
                                             throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called when a packet is send from the user who is owner of the session to the local server (ping, roster management, privacy lists, etc...). There is no default implementation for the method.
      Specified by:
        `processFromUserToServerPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `connectionId` - is a `JID` instance with the session connection ID.
        `packet` - is a `Packet` sent by the user.
        `session` - is a `XMPPResourceConnection` instance with all the sending user session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### processNullSessionPacket

          public void processNullSessionPacket​(Packet packet,
                                               NonAuthUserRepository repo,
                                               java.util.Queue<Packet> results,
                                               java.util.Map<java.lang.String,​java.lang.Object> settings)
                                        throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called for packets received by the server for which no user session is found - neither sender session or receiver session. The default implementation does nothing, just ignores such a packet. To change the default behaviour the method has to be overwritten.
      Overrides:
        `processNullSessionPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `packet` - is a `Packet` received by the server.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### processServerSessionPacket

          public void processServerSessionPacket​(Packet packet,
                                                 XMPPResourceConnection session,
                                                 NonAuthUserRepository repo,
                                                 java.util.Queue<Packet> results,
                                                 java.util.Map<java.lang.String,​java.lang.Object> settings)
                                          throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      The method is called when a packet addressed to the server domain is received. Please note, if a local user sends a packet to the server, the packet is handled by the `processFromUserPacket(...)` method. This method is not called for such packets.
      Specified by:
        `processServerSessionPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `packet` - is a `Packet` received by the server and addressed to the server - the server virtual domain name.
        `session` - is a `XMPPResourceConnection` instance with all the server session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.

    - #### processToUserPacket

          public void processToUserPacket​(Packet packet,
                                          XMPPResourceConnection session,
                                          NonAuthUserRepository repo,
                                          java.util.Queue<Packet> results,
                                          java.util.Map<java.lang.String,​java.lang.Object> settings)
                                   throws PacketErrorTypeException

      Description copied from class: `XMPPProcessorAbstract`
      Method is called for all the packets sent TO the user - owner of the session. The default implementation just forwards the packet to the user connection. To change the default behavior the method has to be overwritten.
      Overrides:
        `processToUserPacket` in class `XMPPProcessorAbstract`
      Parameters:
        `packet` - is a `Packet` received by the server and addressed to the server - the server virtual domain name.
        `session` - is a `XMPPResourceConnection` instance with all the receiving user session data.
        `repo` - is a `NonAuthUserRepository` instance giving access to a part of the user repository which is accessible regardless the session is authenticated or not.
        `results` - is a packets `Queue` with all the processing results from the plugin.
        `settings` - is a `Map` with all the configuration settings passed to the plugin.
      Throws:
        `PacketErrorTypeException` - on attempt to send an error response to the error packet.